package luj.tools.BookBuyer;

class ISBNValidator
{
	public static boolean validate(String strValue)
	{
		String isbn = strValue.replaceAll("\\D", "");
		if (isbn.length() == 10)
		{
			// or direct using the index, but array is easy to understand!
			int[] weight = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
			int sum = 0;
			for (int i = 0; i < 10; ++i)
			{
				sum += (isbn.charAt(i) - 48) * weight[i];
			}

			return (sum % 11 == 0);
		}
		else if (isbn.length() == 13)
		{
			int[] weight = { 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1 };
			int sum = 0;
			for (int i = 0; i < 13; ++i)
			{
				sum += (isbn.charAt(i) - 48) * weight[i];
			}

			return (sum % 10 == 0);
		}
		else
		{
			return false;
		}
	}
}