package luj.tools.BookBuyer;

import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import luj.tools.BookBuyer.ShopConfiguration;

public class ShopFactory
{
	public static ShopFactory getInstance()
	{
		if (mInstance == null)
		{
			mInstance = new ShopFactory();
			mInstance.createShopList();
		}
		return mInstance;
	}

	public ShopInspector createShopInspector(String shopName)
	{
		ShopConfiguration config = null;
		if (mShopConfigs.containsKey(shopName))
		{
			config = mShopConfigs.get(shopName);
		}
		else
		{
			return null;
		}
		
		ShopInspector inspector = null;
		if (config.isGeneric())
		{
			inspector = new ShopInspector(config);
		}
		else if (shopName.equalsIgnoreCase("Chinapub"))
		{
			inspector = new ShopChinapubInspector(config);
		}
		else if(shopName.equalsIgnoreCase("京东"))
		{
			inspector = new ShopBuy360Inspector(config);
		}

		return inspector;
	}
	
	public ShopConfiguration getShopConfiguration(String shopName)
	{
		return mShopConfigs.get(shopName);
	}
	
	private void createShopList()
	{
		// build-in shop list, local
		mShopConfigs = new HashMap<String, ShopConfiguration>();
		mBuildinShopList = new Vector<String>();
		DataExchange.getIntance().loadShopConfiguration(mShopConfigs, mBuildinShopList);
	}
	
	public Vector<String> getBuildinShopList()
	{
		return mBuildinShopList;
	}
	
	private static ShopFactory				mInstance;

	private Map<String, ShopConfiguration>	mShopConfigs;
	
	private Vector<String>					mBuildinShopList;
}