package luj.tools.BookBuyer;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.DOMException;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public final class XMLParseHelper
{		
	public static Node SelectSingleNode(String express, Object source)
	{
        XPathFactory xpathFactory=XPathFactory.newInstance();
        XPath xpath=xpathFactory.newXPath();
        try
		{
            Node result=(Node) xpath.evaluate(express, source, XPathConstants.NODE);
			return result;
        }
		catch (XPathExpressionException e)
		{
            e.printStackTrace();
        }
        
        return null;
    }
    
    public static NodeList SelectNodes(String express, Object source) 
	{
        XPathFactory xpathFactory=XPathFactory.newInstance();
        XPath xpath=xpathFactory.newXPath();
        try
		{
           NodeList result = (NodeList) xpath.evaluate(express, source, XPathConstants.NODESET);
		   return result;
        }
		catch (XPathExpressionException e)
		{
            e.printStackTrace();
        }
        
        return null;
    }
    
	public static String getTextContent(Node node) throws DOMException
	{
		String textContent = "";
		
		if (node.getNodeType() == Node.ATTRIBUTE_NODE)
		{
			textContent = node.getNodeValue();	
		}
		else
		{
			Node child = node.getFirstChild();
			if (child != null)
			{
				Node sibling = child.getNextSibling();
				if (sibling != null)
				{
					StringBuffer sb = new StringBuffer();
					getTextContent(node, sb);
					textContent = sb.toString();
				}
				else
				{					
					if (child.getNodeType() == Node.TEXT_NODE)			
					{
						textContent = child.getNodeValue();
					}
					else
					{
						textContent = getTextContent(child);
					}
				}
			}
		}
		
		return textContent;
	}
	
	private static void getTextContent(Node node, StringBuffer sb) throws DOMException
	{
	    Node child = node.getFirstChild();
	    while (child != null)
	    {
			if (child.getNodeType() == Node.TEXT_NODE)			
			{
				sb.append(child.getNodeValue());
			}
			else
			{
				getTextContent(child, sb);
			}
	        child = child.getNextSibling();
	    }
	}
}