package luj.tools.BookBuyer;

import java.util.HashMap;
import java.util.Map;

public class Book
{
	// constructor
	public Book(String isbn)
	{
		mSelected = true;
		mBookBasicInfor = new BookBasicInfor(isbn);
		mBookInShops = new HashMap<String, BookSaleInfor>();
	}

	public BookBasicInfor getBasicInfor()
	{
		return mBookBasicInfor;
	}
	
	public Map<String, BookSaleInfor> getSaleInfor()
	{
		return mBookInShops;
	}

	public BookSaleInfor getSaleInfor(String shop)
	{
		if (mBookInShops.containsKey(shop))
		{
			return mBookInShops.get(shop);
		}
		else
		{
			BookSaleInfor infor = new BookSaleInfor();
			mBookInShops.put(shop, infor);
			return infor;
		}
	}

	public void setSelected(boolean selected)
	{
		mSelected = selected;
	}

	public boolean getSelected()
	{
		return mSelected;
	}

	// this book is selected
	private boolean						mSelected;

	// book basic information
	private BookBasicInfor				mBookBasicInfor;

	// sale information in respective shop
	private Map<String, BookSaleInfor>	mBookInShops;

	// basic information
	public class BookBasicInfor
	{
		public BookBasicInfor(String isbn)
		{
			mISBN = isbn;
		}

		public String getISBN()
		{
			return mISBN;
		}
		
		public int getPriority()
		{
			return mPriority;
		}
		
		public void setPriority(int value)
		{
			mPriority = value;
		}

		public void setName(String name)
		{
			mName = name;
		}

		public String getName()
		{
			return mName;
		}

		public void setAuthor(String author)
		{
			mAuthor = author;
		}

		public String getAuthor()
		{
			return mAuthor;
		}

		public void setPublisher(String publisher)
		{
			mPublisher = publisher;
		}

		public String getPublisher()
		{
			return mPublisher;
		}

		public void setPrice(float price)
		{
			mPrice = price;
		}

		public float getPrice()
		{
			return mPrice;
		}
		
		public void setPriceUnit(String unit)
		{
			mPriceUnit = unit;
		}

		public String getPriceUnit()
		{
			return mPriceUnit;
		}

		private String	mISBN;
		private int		mPriority = -1;
		private String	mName;
		private String	mAuthor;
		private String	mPublisher;
		private float	mPrice	= -1f;
		private String	mPriceUnit = "";
	}

	// sale information in shops <shop_name, sale_information>
	public class BookSaleInfor
	{
		private boolean	mState			= false;	// true is on sale, false is absent
		private long	mTimeStampMS	= 0;
		private float	mDiscountPrice	= -1f;
		private String	mLink;

		public BookSaleInfor()
		{
		}

		public boolean getState()
		{
			return mState;
		}
		
		public long getTimeStamp()
		{
			return mTimeStampMS;
		}
		
		public void setTimeStamp(long value)
		{
			mTimeStampMS = value;
		}

		public void setPrice(float price)
		{
			mState = true;
			mDiscountPrice = price;
		}

		public float getPrice()
		{
			return mDiscountPrice;
		}

		public void setLink(String link)
		{
			mLink = link;
		}

		public String getLink()
		{
			return mLink;
		}
	}
}