package luj.tools.BookBuyer;

import java.util.Vector;

import android.content.Context;

public class GlobalOption
{
	public static GlobalOption getInstance()
	{
		if (mInstance == null)
		{
			mInstance = new GlobalOption();
		}
		return mInstance;
	}

	public EInquireMode getInquireMode()
	{
		if (mInquireMode == EInquireMode.eCloud && mCloudLink != null
				&& mCloudLink.length()!=0)
		{
			return EInquireMode.eCloud;
		}
		else
		{
			return EInquireMode.eClient;
		}
	}

	public String getCloudLink()
	{
		return mCloudLink;
	}

	public void setInquireMode(EInquireMode mode, String link)
	{
		mInquireMode = mode;
		mCloudLink = link;
	}

	// max number of shop
	public final static int		MAX_NUMBER_SHOP	= 4;
	public final static int		MAX_NUMBER_Book	= 20;
	public final static String	CLIENT			= "CLIENT";
	public final static String	CLOUD			= "CLOUD";

	public enum EInquireMode
	{
		eClient, eCloud
	}

	public void setCurrentContext(Context context)
	{
		mContext = context;
	}

	public Context getCurrentContext()
	{
		return mContext;
	}
	
	public String getGlobalOptionFile()
	{
		return mGlobalOptionFile;
	}

	public String getLibraryFile()
	{
		return mLibraryFile;
	}
	
	public String getShopConfigFile()
	{
		return mShopConfigFile;
	}
	
	public int getDataExpireHour()
	{
		return mDataExpireHour;
	}
	
	public void setDataExpireHour(int value)
	{
		if (value>=0 && value<=24)
		{
			mDataExpireHour = value;
		}
	}
	
	void setSelectedShops(Vector<String> shops)
	{
		mSelectedShops = shops;
	}
	
	Vector<String> getSelectedShops()
	{
		// if the selected list is empty, fill it
		if (mSelectedShops.size() == 0)
		{
			if (getInquireMode() == EInquireMode.eClient)
			{
				// copy 4 elements from mBuildinShopList to selectedShops
				mSelectedShops.addAll(ShopFactory.getInstance().getBuildinShopList());
			}
			else
			{
				// copy 4 elements from mCloudShopList to selectedShops
				if (ShopFactory.getInstance().getCloudShopList().size() > 0)
				{
					mSelectedShops.addAll(ShopFactory.getInstance().getCloudShopList());
				}
				else
				{
					mSelectedShops.addAll(ShopFactory.getInstance().getBuildinShopList());
					setInquireMode(EInquireMode.eClient, null);
				}
			}

			// save change.
			DataExchange.getIntance().saveGlobalOption();
		}
		return mSelectedShops;
	}
	
	private static GlobalOption	mInstance;
	private EInquireMode		mInquireMode		= EInquireMode.eClient;
	private String				mCloudLink;
	private Context				mContext;
	private String				mGlobalOptionFile	= "option.xml";
	private String				mLibraryFile		= "library.xml";
	private String				mShopConfigFile		= "shop_config.xml";
	private Vector<String>		mSelectedShops;
	private int					mDataExpireHour		= 1;	
}