package luj.tools.BookBuyer;

import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

public class Library
{
	public static Library getInstance()
	{
		if (smIntance == null)
		{
			smIntance = new Library();
		}
		return smIntance;
	}

	// get account of books
	int getBookCount()
	{
		return mBooks.size();
	}

	// add a book
	public boolean addBook(String isbn)
	{
		if (mBooks.size() >= GlobalOption.MAX_NUMBER_Book)
		{
			return false;
		}
		
		if (mMapBooks.containsKey(isbn))
		{
			return false;
		}
		else
		{
			Book book = new Book(isbn);
			mMapBooks.put(isbn, book);
			mBooks.add(isbn);
			return true;
		}
	}

	// delete a book by ISBN
	public boolean deleteBook(String isbn)
	{
		if (mMapBooks.containsKey(isbn))
		{
			mMapBooks.remove(isbn);
			mBooks.remove(isbn);
			return true;
		}
		else
		{
			return false;
		}
	}

	// delete a book by the position
	public boolean deleteBook(int position)
	{
		if (position < mBooks.size())
		{
			String isbn = mBooks.get(position);
			mBooks.remove(position);
			mMapBooks.remove(isbn);
			return true;
		}
		else
		{
			return false;
		}
	}

	// get a book by ISBN
	public Book getBook(String isbn)
	{
		if (mMapBooks.containsKey(isbn))
		{
			return mMapBooks.get(isbn);
		}
		else
		{
			return null;
		}
	}

	// get a book by position
	public Book getBook(int position)
	{
		if (position < mBooks.size())
		{
			String isbn = mBooks.get(position);
			return mMapBooks.get(isbn);
		}
		else
		{
			return null;
		}
	}

	// the singleton instance of library
	static Library				smIntance;

	// book ISBN list, it's sorted
	private Vector<String>		mBooks		= new Vector<String>();

	// map ISBN -> Book
	private Map<String, Book>	mMapBooks	= new HashMap<String, Book>();
}