package luj.tools.BookBuyer;

import java.util.List;

import org.apache.http.NameValuePair;

public class ShopConfiguration
{
	// constructor
	public ShopConfiguration(String shopName)
	{
		mShopName = shopName;
	}

	public String getName()
	{
		return mShopName;
	}
	
	public String getDescription()
	{
		return mShopDescription;
	}

	public void setDescription(String description)
	{
		mShopDescription = description;
	}

	public boolean isGeneric()
	{
		return mIsGeneric;
	}

	public void setGeneric(boolean isGeneric)
	{
		this.mIsGeneric = isGeneric;
	}
	
	public int getPriority()
	{
		return mPriority;
	}
	
	public void setPriority(int value)
	{
		mPriority = value;
	}
	
	public String getUnit()
	{
		return mUnit;
	}
	
	public void setUnit(String unit)
	{
		mUnit = unit;
	}

	public boolean isHttpGetProtocol()
	{
		return (mHttpGetLink != null && mHttpGetLink.length() > 5);
	}

	public boolean isHttpPostProtocol()
	{
		return (mHttpPostParams != null);
	}

	public void setHttpGetLink(String link)
	{
		mHttpGetLink = link;
	}

	public String getHttpGetLink()
	{
		return mHttpGetLink;
	}

	public void setHttpPostLink(String link)
	{
		mHttpPostLink = link;
	}

	public String getHttpPostLink()
	{
		return mHttpPostLink;
	}

	public void setHttpPostParams(List<NameValuePair> params)
	{
		mHttpPostParams = params;
	}

	public List<NameValuePair> getHttpPostParames()
	{
		return mHttpPostParams;
	}
	
	public boolean needJumpPage()
	{
		return (mJumpElement.getPath() != null && mJumpElement.getPath()
				.length() > 0);
	}
	
	public void setJumpElement(InformationElement element)
	{
		mJumpElement = element;
	}

	public InformationElement getJumpElement()
	{
		return mJumpElement;
	}

	public void setBookElement(InformationElement element)
	{
		mBookElement = element;
	}

	public InformationElement getBookElement()
	{
		return mBookElement;
	}

	public void setISBNElement(InformationElement element)
	{
		mISBNElement = element;
	}

	public InformationElement getISBNElement()
	{
		return mISBNElement;
	}

	public void setBooknameElement(InformationElement element)
	{
		mBooknameElement = element;
	}

	public InformationElement getBooknamElement()
	{
		return mBooknameElement;
	}

	public void setAuthorElement(InformationElement element)
	{
		mAuthorElement = element;
	}

	public InformationElement getAuthorlement()
	{
		return mAuthorElement;
	}

	public void setPublisherElement(InformationElement element)
	{
		mPublisherElement = element;
	}

	public InformationElement getPublisherElement()
	{
		return mPublisherElement;
	}

	public void setLinkElement(InformationElement element)
	{
		mLinkElement = element;
	}

	public InformationElement getLinkElement()
	{
		return mLinkElement;
	}

	public void setPriceElement(InformationElement element)
	{
		mPriceElement = element;
	}

	public InformationElement getPriceElement()
	{
		return mPriceElement;
	}

	public void setDiscountElement(InformationElement element)
	{
		mDiscountElement = element;
	}

	public InformationElement getDiscountElement()
	{
		return mDiscountElement;
	}

	// node type to get the real value
	public final static String	CONTENT		= "CONTENT";
	public final static String	ATTRIBUTE	= "ATTRIBUTE";
	public final static String	SCRIPT		= "SCRIPT";
	public final static String	GET			= "GET";
	public final static String	POST		= "POST";

	public enum ENodeType
	{
		eUNDEFINED, eCONTENT, eATTRIBUTE, eSCRIPT
	}

	// the name of this shop
	private final String		mShopName;
	
	// the description
	private String				mShopDescription;

	// this shop can be handled in generic or not
	private boolean				mIsGeneric			= true;
	
	// the priority, the higher priority will be list on front
	private int					mPriority			= 0;
	
	// the unit of money
	private String				mUnit				= "";
	
	// the type of HTTP protocol, support Get/post!
	// Get
	private String				mHttpGetLink;
	// Post
	private String				mHttpPostLink;
	private List<NameValuePair>	mHttpPostParams;
	
	// the Element of book in XML file
	private InformationElement	mJumpElement		= new InformationElement();

	// the Element of book in XML file
	private InformationElement	mBookElement		= new InformationElement();

	// the Element of book name
	private InformationElement	mISBNElement		= new InformationElement();

	// the Element of book name
	private InformationElement	mBooknameElement	= new InformationElement();

	// the Element of author
	private InformationElement	mAuthorElement		= new InformationElement();

	// the Element of publishing
	private InformationElement	mPublisherElement	= new InformationElement();

	// the Element of link
	private InformationElement	mLinkElement		= new InformationElement();

	// the Element of List-price
	private InformationElement	mPriceElement		= new InformationElement();

	// the Element of discount-price
	private InformationElement	mDiscountElement	= new InformationElement();

	public class InformationElement
	{
		public InformationElement()
		{
		}

		public void setPath(String path)
		{
			mPath = path;
		}

		public String getPath()
		{
			return mPath;
		}

		public void setValueType(ENodeType value)
		{
			mValue = value;
		}

		public ENodeType getValueType()
		{
			return mValue;
		}

		public void setAttribute(String attribute)
		{
			mAttribute = attribute;
		}

		public String getAttribute()
		{
			return mAttribute;
		}

		public void setDigits(int Digits)
		{
			mDigits = Digits;
		}

		public int getDigits()
		{
			return mDigits;
		}

		private String		mPath;
		private ENodeType	mValue;
		private String		mAttribute;	// // if ENodeType is Attribute,
											// this field 'll be used
		private int			mDigits	= 2;	// the number of decimal digits
	}
}